---
title: MediaQueryList
slug: Web/API/MediaQueryList
tags:
  - API
  - Adaptive Design
  - CSSOM View
  - DOM
  - Interface
  - Media Queries
  - MediaQueryList
  - Reference
  - query
---
<p>{{APIRef("CSSOM")}}</p>

<p><span class="seoSummary">A <strong><code>MediaQueryList</code></strong> object stores information on a <a href="/en-US/docs/Web/CSS/Media_Queries">media query</a> applied to a document, with support for both immediate and event-driven matching against the state of the document.</span> You can create a <code>MediaQueryList</code> by calling {{DOMxRef("Window.matchMedia", "matchMedia()")}} on the {{DOMxRef("window")}} object. The resulting object handles sending notifications to listeners when the media query state changes (i.e. when the media query test starts or stops evaluating to <code>true</code>).</p>

<p>This is very useful for adaptive design, since this makes it possible to observe a document to detect when its media queries change, instead of polling the values periodically, and allows you to programmatically make changes to a document based on media query status.</p>

<h2 id="Properties">Properties</h2>

<p><em>The <code>MediaQueryList</code> interface inherits properties from its parent interface, {{DOMxRef("EventTarget")}}.</em></p>

<dl>
 <dt>{{DOMxRef("MediaQueryList.matches", "matches")}}{{ReadOnlyInline}}</dt>
 <dd>A {{jsxref("Boolean")}} that returns <code>true</code> if the {{DOMxRef("document")}} currently matches the media query list, or <code>false</code> if not.</dd>
 <dt>{{DOMxRef("MediaQueryList.media", "media")}}{{ReadOnlyInline}}</dt>
 <dd>A {{DOMxRef("DOMString")}} representing a serialized media query.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>The <code>MediaQueryList</code> interface inherits methods from its parent interface, {{DOMxRef("EventTarget")}}.</em></p>

<dl>
 <dt>{{DOMxRef("MediaQueryList.addListener", "addListener()")}}</dt>
 <dd>Adds to the <code>MediaQueryList</code> a callback which is invoked whenever the media query status—whether or not the document matches the media queries in the list—changes. This method exists primarily for backward compatibility; if possible, you should instead use {{domxref("EventTarget.addEventListener", "addEventListener()")}} to watch for the {{domxref("EventTarget.change_event", "change")}} event.</dd>
 <dt>{{DOMxRef("MediaQueryList.removeListener", "removeListener()")}}</dt>
 <dd>Removes the specified listener callback from the callbacks to be invoked when the <code>MediaQueryList</code> changes media query status, which happens any time the document switches between matching and not matching the media queries listed in the <code>MediaQueryList</code>. This method has been kept for backward compatibility; if possible, you should generally use {{domxref("EventTarget.removeEventListener", "removeEventListener()")}} to remove change notification callbacks (which should have previously been added using <code>addEventListener()</code>).</dd>
</dl>

<h2 id="Events">Events</h2>

<p><em>The following events are delivered to <code>MediaQueryList</code> objects:</em></p>

<dl>
 <dt>{{DOMxRef("MediaQueryList.change_event", "change")}}</dt>
 <dd>Sent to the <code>MediaQueryList</code> when the result of running the media query against the document changes. For example, if the media query is <code>(min-width: 400px)</code>, the <code>change</code> event is fired any time the width of the document's {{Glossary("viewport")}} changes such that its width moves across the 400px boundary in either direction.<br>
 Also available using the {{DOMxRef("MediaQueryList.onchange", "onchange")}} event handler property.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This simple example creates a <code>MediaQueryList</code> and then sets up a listener to detect when the media query status changes, running a custom function when it does to change the appearence of the page.</p>

<pre class="brush: js notranslate">var para = document.querySelector('p');
var mql = window.matchMedia('(max-width: 600px)');

function screenTest(e) {
  if (e.matches) {
    /* the viewport is 600 pixels wide or less */
    para.textContent = 'This is a narrow screen — less than 600px wide.';
    document.body.style.backgroundColor = 'red';
  } else {
    /* the viewport is more than than 600 pixels wide */
    para.textContent = 'This is a wide screen — more than 600px wide.';
    document.body.style.backgroundColor = 'blue';
  }
}

mql.addEventListener('change', screenTest);</pre>

<div class="note">
<p><strong>Note</strong>: You can find this example on GitHub (see the <a href="https://github.com/mdn/dom-examples/blob/master/mediaquerylist/index.html">source code</a>, and also see it <a href="https://mdn.github.io/dom-examples/mediaquerylist/index.html">running live</a>).</p>
</div>

<p>You can find other examples on the individual property and method pages.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSSOM View", "#the-mediaquerylist-interface", "MediaQueryList")}}</td>
   <td>{{Spec2("CSSOM View")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaQueryList")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/CSS/Media_queries">Media queries</a></li>
 <li><a href="/en-US/docs/CSS/Using_media_queries_from_code">Using media queries from code</a></li>
 <li>{{DOMxRef("window.matchMedia()")}}</li>
 <li>{{DOMxRef("MediaQueryListEvent")}}</li>
 <li>The article {{DOMxRef("Window.devicePixelRatio")}} also has a useful example</li>
</ul>
